package acumuladores;

public class Acumuladores {
	
	public boolean todosMultiplosEnAlgunaFila(int[][] mat, int num) {
		//Chequeos de la consigna
		if (mat.length == 0 || num <= 0) return false;
		if (mat[0].length == 0) return false;
		//Acumuladores
		int filas    = mat   .length;
		int columnas = mat[0].length;
		boolean acumFilas = false;
		for( int contFilas = 0 ; contFilas < filas ; contFilas++ ) {
			if (mat[contFilas].length != columnas) throw new IllegalArgumentException("mat no es una matriz."); // Otro chequeo más (no está en la consigna)
			boolean acumColumnas = true;
			for( int contColumnas = 0 ; contColumnas < columnas ; contColumnas++ ) {
				acumColumnas = acumColumnas && (mat[contFilas][contColumnas] % num == 0);
			}
			acumFilas = acumFilas || acumColumnas;
		}
		//Fin
		return acumFilas;
	}
	
	public boolean hayInterseccionPorFila(int[][] mat1, int[][]mat2) {
		int filas = mat1.length;
		//Chequeos de la consigna
		if (filas != mat2.length || filas == 0) return false;
		int columnas1 = mat1[0].length; int columnas2 = mat2[0].length;
		//Chequeos de la consigna
		if (columnas1 == 0 || columnas2 == 0) return false;
		//Acumuladores
		boolean acumFilas = true;
		for ( int contFilas = 0 ; contFilas < filas ; contFilas++) {
			if (mat1[contFilas].length != columnas1) throw new IllegalArgumentException("mat1 no es una matriz."); // Otro chequeo más (no está en la consigna)
			if (mat2[contFilas].length != columnas2) throw new IllegalArgumentException("mat2 no es una matriz."); // Otro chequeo más (no está en la consigna)
			boolean acumColumnas1 = false;
			for ( int contColumnas1 = 0 ; contColumnas1 < columnas1 ; contColumnas1++) {
				boolean acumColumnas2 = false;
				for ( int contColumnas2 = 0 ; contColumnas2 < columnas2 ; contColumnas2++) {
					acumColumnas2 = acumColumnas2 || (mat1[contFilas][contColumnas1] == mat2[contFilas][contColumnas2]); //¿Són los números iguales?
				}
				acumColumnas1 = acumColumnas1 || acumColumnas2; //Ver si hubo alguna intersección en la fila hasta ahora
			}
			acumFilas = acumFilas && acumColumnas1; //Ver si todas las filas que comparamos hasta ahora tienen intersección
		}
		return acumFilas;
	}
	
	public boolean algunaFilaSumaMasQueLaColumna(int[][] mat, int nColum) {
		//Chequeos de la consigna
		if (mat.length == 0) return false;
		int filas    = mat   .length;
		int columnas = mat[0].length;
		//Chequeos de la consigna
		if (columnas == 0 || nColum >= columnas || nColum < 0) return false;
		//Suma de la columna
		int sumaColumna = 0;
		for (int contFilas = 0 ; contFilas < filas ; contFilas++) {
			if (mat[contFilas].length != columnas) throw new IllegalArgumentException("mat no es una matriz."); // Otro chequeo más (no está en la consigna)
			sumaColumna = sumaColumna + mat[contFilas][nColum];
		}
		//Acumuladores
		boolean acumFilas = false;
		for (int contFilas = 0 ; contFilas < filas ; contFilas++) {
			int sumaFila = 0;
			for( int contColumnas = 0 ; contColumnas < columnas ; contColumnas++ ) {
				sumaFila = sumaFila + mat[contFilas][contColumnas];
			}
			acumFilas = acumFilas || (sumaFila > sumaColumna);
		}
		//Fin
		return acumFilas;
	}
	
	public boolean hayInterseccionPorColumna(int[][] mat1, int[][]mat2) {
		int filas1 = mat1.length; int filas2 = mat2.length;
		//Chequeos de la consigna
		if (filas1 == 0 || filas2 == 0) return false;
		int columnas = mat1[0].length;
		//Chequeos de la consigna
		if (columnas != mat2[0].length || columnas == 0) return false;
		//Acumuladores
		boolean acumColumnas = true;
		for ( int contColumnas = 0 ; contColumnas < columnas ; contColumnas++ ) {
			boolean acumFilas1 = false;
			for ( int contFilas1 = 0 ; contFilas1 < filas1 ; contFilas1++ ) {
				boolean acumFilas2 = false;
				for ( int contFilas2 = 0 ; contFilas2 < filas2 ; contFilas2++ ) {
					acumFilas2 = acumFilas2 || (mat1[contFilas1][contColumnas] == mat2[contFilas2][contColumnas]); //¿Són los números iguales?
				}
				acumFilas1 = acumFilas1 || acumFilas2;  //Ver si hubo alguna intersección en la fila hasta ahora
			}
			acumColumnas = acumColumnas && acumFilas1; //Ver si todas las filas que comparamos hasta ahora tienen intersección
		}
		//Fin
		return acumColumnas;
	}
	
}
